﻿using System;
using System.Collections.Generic;
using System.Text;
using System.Windows.Forms;
using System.Linq;

using  Autodesk.Revit .DB;
using Autodesk.Revit.DB.Architecture;
using Autodesk.Revit.UI;
using Autodesk.Revit .ApplicationServices;
using Autodesk.Revit.Attributes ;
using Autodesk.Revit.UI.Selection;


  [TransactionAttribute(Autodesk.Revit.Attributes.TransactionMode.Manual)]
public class FindFurnitureInARoom : IExternalCommand
{
    public Result Execute(ExternalCommandData commandData, ref string messages, ElementSet elements)
    {

      UIApplication app = commandData.Application;
      Document document = app.ActiveUIDocument.Document;
      //pick a room
      Selection sel = app.ActiveUIDocument.Selection ;
      Reference ref1 = sel.PickObject( ObjectType.Element, "Please pick a room");
      Room room = document.GetElement(ref1) as Room;

      ParameterValueProvider provider = new ParameterValueProvider(new ElementId(BuiltInParameter.ELEM_ROOM_ID));
      FilterNumericRuleEvaluator evaluator = new FilterNumericEquals();

      FilterElementIdRule rule = new FilterElementIdRule(provider, evaluator, room.Id);
      ElementParameterFilter filter = new ElementParameterFilter(rule);

      FilteredElementCollector collector = new FilteredElementCollector(document);
      collector.WherePasses(filter);
            
      sel = app.ActiveUIDocument.Selection;
      sel.Elements.Clear();
      foreach (Element elem in collector)
        sel.Elements.Add(elem);

      TaskDialog.Show("The number", "The number of components = " + collector.Count().ToString());
      return Result.Succeeded ;
    }
}

